image: maven:3.6.1-jdk-11

variables:
  # This will suppress any download for dependencies and plugins or upload messages which would clutter the console log.
  MAVEN_CLI_OPTS: "--batch-mode --errors --fail-at-end --show-version"
  MAVEN_OPTS: "-Dmaven.repo.local=$CI_PROJECT_DIR/.m2/repository -Dorg.slf4j.simpleLogger.log.org.apache.maven.cli.transfer.Slf4jMavenTransferListener=WARN -Dorg.slf4j.simpleLogger.showDateTime=true -Djava.awt.headless=true"

cache:
  key: ${CI_COMMIT_REF_SLUG}
  paths:
    - .m2/repository/
    - ./**/target/

build:
  stage: build
  script:
    - mvn $MAVEN_CLI_OPTS compile

test:
  stage: test
  script:
    - mvn $MAVEN_CLI_OPTS verify
  artifacts:
    expire_in: 2day
    paths:
      - lutra-cli/target/lutra.jar
      - lutra-restapi/target/lutra.war

.deploy: &deploy
  stage: deploy
  script:
    - cp lutra-cli/target/lutra.jar lutra.jar
    - cp lutra-restapi/target/lutra.war lutra.war

snapshot:
  <<: *deploy
  only:
    - develop
    - master
  artifacts:
    expire_in: 6 mos 1day
    paths:
      - lutra.jar
      - lutra.war

release:
  <<: *deploy
  only:
    - tags
  artifacts:
    expire_in: 48 mos 1day
    paths:
    - lutra.jar
    - lutra.war

include:
  - template: Code-Quality.gitlab-ci.yml
  - template: Dependency-Scanning.gitlab-ci.yml
  - template: Security/License-Scanning.gitlab-ci.yml
  - template: Security/Secret-Detection.gitlab-ci.yml
  - template: Security/SAST.gitlab-ci.yml

spotbugs-sast:
  dependencies:
    - build
  variables:
    MAVEN_REPO_PATH: $CI_PROJECT_DIR/.m2/repository
    COMPILE: "false"
  artifacts:
    reports:
      sast: gl-sast-report.json
      